/**
	$Id: JdbcWork.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.hibernate;

import net.sf.basedb.core.HibernateUtil;

import org.hibernate.Session;
import org.hibernate.jdbc.Work;

/**
	An extension to Hibernate's {@link Work} API which adds functionality
	for returning a value as a result from the work. 

	@author nicklas
	@version 2.9
	@base.modified $Date: 2008-09-11 22:11:02 +0200 (Thu, 11 Sep 2008) $
	@see HibernateUtil#doJdbcWork(Session, JdbcWork)
*/
public interface JdbcWork<R>
	extends Work
{

	/**
		Get the result of the work.
	*/
	public R getResult();
}
