/**
	$Id: DeletedFilter.java 5603 2011-04-08 12:50:27Z nicklas $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.extensions.manager.filter;

import net.sf.basedb.util.extensions.manager.ExtensionsFile;
import net.sf.basedb.util.filter.Filter;

/**
	Filter implementation for extension files that 
	allow only deleted files to pass.
	
	@author Nicklas
	@since 3.0
	@base.modified $Date: 2011-04-08 14:50:27 +0200 (Fri, 08 Apr 2011) $
*/
public class DeletedFilter
	implements Filter<ExtensionsFile>
{
	
	private static final org.apache.log4j.Logger log = 
		org.apache.log4j.LogManager.getLogger("net.sf.basedb.util.extensions.manager.filter.DeletedFilter");

	
	/**
		Create a new filter.
	*/
	public DeletedFilter()
	{}
	
	/*
		From the Filter interface
		-------------------------
	*/
	@Override
	public boolean evaluate(ExtensionsFile xtFile)
	{
		if (xtFile.exists()) 
		{
			log.info("File exists (skipping): " + xtFile);
			return false;
		}
		return true;
	}
	// -------------------------
	
	
}
