<%-- $Id:manual_scan.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
 	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.manager.ExtensionsFile"
	import="net.sf.basedb.util.extensions.manager.ProcessResults"
	import="net.sf.basedb.util.extensions.manager.ProcessResults.FileResults"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.formatter.Formatter"
	import="java.util.Date"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	ExtensionsControl ec = ExtensionsControl.get(dc);
	ProcessResults results = ec.getLastScanResults();
	Formatter timeFormatter = FormatterFactory.getDateTimeFormatter(sc);
%>
	<base:page type="popup" title="Last installation results">
	<base:head>
	<script language="javascript">
	function showDetails(detailsId)
	{
		Main.showHide('details.' + detailsId);
		var icon = document.getElementById('icon.'+detailsId);
		if (icon)
		{
			if (icon.src.indexOf('show') > 0)
			{
				icon.src = icon.src.replace('show', 'hide');
			}
			else
			{
				icon.src = icon.src.replace('hide', 'show');
			}	
		}
	}
	</script>
	</base:head>
	<base:body>
	<p>

	<h3 class="docked">Last installation results</h3>
	<div class="boxedbottom" style="height: <%=(int)(scale*280)%>px; overflow: auto;">

		<table class="form">
		<tr>
			<td class="prompt">Status</td>
			<td colspan="3"><%=results.hasError() ? "Error" : "Success" %></td>
		</tr>
		<tr>
			<td class="prompt">Started</td>
			<td><%=timeFormatter.format(new Date(results.getStartTime()))%></td>
			<td class="prompt">Ended</td>
			<td><%=timeFormatter.format(new Date(results.getEndTime()))%></td>
		</tr>
		<tr>
			<td class="prompt">Summary</td>
			<td colspan="3"><%=HTML.niceFormat(results.getSummary())%></td>
		</tr>
		</table>
	
		<table class="form">
		<%
		for (FileResults fileResults : results.getAllResults())
		{
			ExtensionsFile extFile = fileResults.getExtensionsFile();
			String detailsId = Integer.toString(extFile.hashCode());
			List<String> messages = fileResults.getMessages();
			Throwable validationError = extFile.getValidationError();
			boolean hasMessages = (messages != null && messages.size() > 0) || validationError != null;
			%>
			<tr>
				<td class="prompt"><%=extFile.getName() %></td>
				<td><%=fileResults.getStatus() %>
				<base:icon 
					id="<%="icon." + detailsId %>" 
					image="show_section.gif" 
					onclick="<%="showDetails('" + detailsId + "')" %>" 
					visible="<%=hasMessages%>"
				/>
				</td>
			</tr>
			<%
			if (hasMessages)
			{
				%>
				<tr id="details.<%=detailsId %>" style="display:none;">
					<td></td><td>
					<ul style="padding-left: 20px; margin: 0px; text-align: left;">
					<%
					for (String msg : messages)
					{
						%>
						<li><%=HTML.niceFormat(msg)%>
						<%
					}
					if (validationError != null)
					{
						%>
						<li><%=validationError.getClass().getSimpleName()%>: <%=HTML.niceFormat(validationError.getMessage())%>
						<%
					}
					%>
					</ul>
					</td>
				</tr>
				<%
			}
		}
		%>
		</table>
	</div>
	
	<p>
	<div align=center>
		<table align="center">
		<tr>
			<td><base:button onclick="window.close();" title="Close" /></td>
		</tr>
		</table>

	</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
