<%-- $Id: view_event.jsp 5642 2011-05-26 07:37:32Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.CommonItem"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateEvent"
	import="net.sf.basedb.core.BioPlateEventParticipant"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOPLATEEVENT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
int bioPlateId = Values.getInt(request.getParameter("bioplate_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	BioPlateEvent event = BioPlateEvent.getById(dc, itemId);
	
	// Load bioplates participating in this event
	ItemQuery<BioPlateEventParticipant> participantQuery = event.getParticipants();
	participantQuery.join(Hql.innerJoin(null, "bioPlate", "bpl", true));
	participantQuery.include(Include.ALL);
	participantQuery.order(Orders.asc(Hql.property("role")));
	participantQuery.order(Orders.asc(Hql.property("index")));
	participantQuery.order(Orders.asc(Hql.property("bpl", "name")));
	ItemResultList<BioPlateEventParticipant> participants = participantQuery.list(dc);
	
	if (bioPlateId == 0)
	{
		for (BioPlateEventParticipant participant : participants)
		{
			try
			{
				bioPlateId = participant.getBioPlate().getId();
				break;
			}
			catch (RuntimeException ex)
			{}
		}
	}
	BioPlate bioPlate = bioPlateId == 0 ? null : BioPlate.getById(dc, bioPlateId);
	
	final boolean usePermission = event.hasPermission(Permission.USE);
	final boolean writePermission = event.hasPermission(Permission.WRITE);
	final boolean deletePermission = event.hasPermission(Permission.DELETE);
	final boolean sharePermission = event.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = event.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = event.isRemoved();
	final boolean isUsed = isRemoved && event.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = event.isOwner();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, event);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="toolbar.css,table.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareEvent', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>&bioplate_id=<%=bioPlateId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>&bioplate_id=<%=bioPlateId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>', '&bioplate_id=<%=bioPlateId%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<%
		if (bioPlate != null)
		{
			%>
			<p:path>
				<p:pathelement title="Bioplates" href="<%="../index.jsp?ID="+ID%>" />
				<p:pathelement 
					title="<%=HTML.encodeTags(bioPlate.getName())%>" 
					href="<%="index.jsp?ID="+ID+"&bioplate_id="+bioPlateId%>" />
				<p:pathelement title="<%=HTML.encodeTags(event.getName())%>" />
			</p:path>
			<%
		}
		else
		{
			%>
			<p:path>
				<p:pathelement title="Bioplate events" />
				<p:pathelement title="<%=HTML.encodeTags(event.getName())%>" />
			</p:path>
			<%
		}
		%>
		<t:tabcontrol id="main" active="properties" switch="switchTab">
		<t:tab id="properties" title="Properties">

		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this event" : "You do not have permission to edit this event"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!event.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this event" : "You do not have permission to delete this event"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=event.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this event" : "You do not have permission to restore this event"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this event to other user, groups and projects" : "You do not have permission to share this event"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			</tbl:toolbar>
			
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(event)%></i></div>
			<%
			if (event.isRemoved() || event.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=event.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(event.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Event date</td>
				<td><%=dateFormatter.format(event.getEventDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Registration date</td>
				<td><%=dateFormatter.format(event.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Event type</td>
				<td><base:propertyvalue item="<%=event%>" property="eventType" /></td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td><base:propertyvalue item="<%=event%>" property="protocol"/></td>
			</tr>
			<tr>
				<td class="prompt">Hardware</td>
				<td><base:propertyvalue item="<%=event%>" property="hardware"/></td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=event%>" property="owner" /></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(event.getDescription())%></td>
			</tr>
			</table>
			
			<%
			// Bioplates participating in this event
			if (participants.size() == 0)
			{
				%>
				<h4>Participating plates</h4>
				No plates are participating in this event
				(or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section 
					id="participantSection" 
					title="<%="Participating plates (" + participants.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="participants"
						clazz="itemlist"
						columns="all"
						>
						<tbl:columndef
							id="bioplate"
							title="Bioplate"
						/>
						<tbl:columndef 
							id="role"
							title="Role"
						/>
						<tbl:columndef
							id="description"
							title="Description"
						/>
						<tbl:data>
							<tbl:columns></tbl:columns>
							<tbl:rows>
								<%
								for (BioPlateEventParticipant participant : participants)
								{
									BioPlate plate = null;
									try
									{
										plate = participant.getBioPlate();
									}
									catch (PermissionDeniedException ex)
									{}
									%>
									<tbl:row>
										<tbl:cell column="bioplate"><base:icon 
											image="deleted.gif" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=plate != null && plate.isRemoved()%>"
										/><%=Base.getLinkedName(ID, plate, true, true)%></tbl:cell>
										<tbl:cell column="role"><%=HTML.encodeTags(participant.getRole())%> [<%=participant.getIndex()%>]</tbl:cell>
										<tbl:cell column="description"><%=plate == null ? "" : HTML.encodeTags(plate.getDescription())%></tbl:cell>
									</tbl:row>
									<%
								}
								%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			// Biomaterial events linked with this event
			ItemQuery<BioMaterialEvent> eventQuery = event.getBioMaterialEvents();
			eventQuery.join(Hql.leftJoin("bioMaterial", "bm"));
			eventQuery.join(Hql.leftJoin("physicalBioAssay", "pba"));
			eventQuery.include(Include.ALL);
			eventQuery.order(Orders.asc(Hql.property("bm", "name")));
			eventQuery.order(Orders.asc(Hql.property("pba", "name")));
			ItemResultList<BioMaterialEvent> events = eventQuery.list(dc);
			if (events.size() == 0)
			{
				%>
				<h4>Related biomaterial events</h4>
				No biomaterial events are linked to this event
				(or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section 
					id="eventsSection" 
					title="<%="Related biomaterial events (" + events.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="events"
						clazz="itemlist"
						columns="all"
						>
						<tbl:columndef
							id="item"
							title="Biomaterial/Bioassay"
						/>
						<tbl:columndef
							id="bioplate"
							title="Bioplate"
						/>
						<tbl:columndef
							id="eventType"
							title="Event type"
						/>
						<tbl:columndef
							id="comment"
							title="Comment"
						/>
						<tbl:data>
							<tbl:columns></tbl:columns>
							<tbl:rows>
								<%
								for (BioMaterialEvent bmEvent : events)
								{
									BioMaterialEvent.Type eventType = bmEvent.getEventType();
									CommonItem item = null;
									try
									{
										if (eventType == BioMaterialEvent.Type.BIOASSAY)
										{
											item = bmEvent.getPhysicalBioAssay();
										}
										else
										{
											item = bmEvent.getBioMaterial();
										}
									}
									catch (PermissionDeniedException ex)
									{}			
									%>
									<tbl:row>
										<tbl:cell column="item"><base:icon 
											image="deleted.gif" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=item != null && item.isRemoved()%>"
										/><%=Base.getLinkedName(ID, item, true, true)%><%=item != null ? " (" +item.getType().toString() + ")" : "" %></tbl:cell>
										<tbl:cell column="bioplate"><base:propertyvalue item="<%=bmEvent%>" property="bioPlateEventParticipant.bioPlate" /></tbl:cell>
										<tbl:cell column="eventType"><%=eventType%></tbl:cell>
										<tbl:cell column="comment"><%=HTML.encodeTags(bmEvent.getComment())%></tbl:cell>
									</tbl:row>
									<%
								}
								%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}			
			%>
			<jsp:include page="../../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this event" />
			</jsp:include>
		</div>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
