<%-- $Id: edit_file.jsp 5812 2011-10-17 14:19:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Config"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileServer"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.nio.charset.Charset"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.FILE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	File file = null;
	Directory directory = null;
	boolean readCurrentSubtype = true;
	int currentSubtypeId = 0;
	boolean readCurrentFileServer = true;
	FileServer currentFileServer = null;
	List<FileServer> recentFileServers = (List<FileServer>)cc.getRecent(dc, Item.FILESERVER);

	if (itemId == 0)
	{
		title = "Create file";
		currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		if (currentSubtypeId == 0) 
		{
			int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
			currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
		}
		if (cc.getPropertyFilter("fileServer.name") != null)
		{
			currentFileServer = Base.getFirstMatching(dc, FileServer.getQuery(), "name", cc.getPropertyFilter("fileServer.name"));
		}
		directory = Directory.getById(dc, Values.getInt(request.getParameter("directory_id"), 
			SystemItems.getId(Directory.ROOT)));
		cc.removeObject("item");
	}
	else
	{
		file = File.getById(dc, itemId);
		file.checkPermission(Permission.WRITE);
		
		directory = file.getDirectory();
		cc.setObject("item", file);
		title = "Edit file -- " + HTML.encodeTags(file.getName());
		try
		{
			ItemSubtype subtype = file.getItemSubtype();
			if (subtype != null) currentSubtypeId = subtype.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
		try
		{
			currentFileServer = file.getFileServer();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFileServer = false;
		}
	}
	
	// Query to retrieve file types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), file);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "File" tab
		function validateFile()
		{
			var frm = document.forms['file'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.url && Main.trimString(frm.url.value) == '')
			{
				alert("You must enter a URL");
				frm.url.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['file'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		var lastAutoChange = '';
		function urlOnChange()
		{
			var frm = document.forms['file'];
			var url = frm.url.value;
			if (url && (lastAutoChange == frm.name.value))
			{
				var end = url.lastIndexOf('/');
				if (end >= 0) url = url.substring(end+1);
				frm.name.value = url;
				lastAutoChange = url;
			}
		}
		function fileServerOnClick()
		{
			var frm = document.forms['file'];
			var url = '../fileservers/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setFileServerCallback';
			if (frm.server_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.server_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectFileServer', 1000, 700);
		}
		function setFileServerCallback(id, name)
		{
			var frm = document.forms['file'];
			var list = frm.server_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}		
		function init()
		{
			<%
			if (file == null)
			{
				%>
				var frm = document.forms['file'];
				var defaultActive = frm.url ? frm.url : frm.name;
				defaultActive.focus();
				defaultActive.select();
				<%
			}
			%>
		}
		function mimeTypeOnClick()
		{
			var frm = document.forms['file'];
			var url = '../../admin/mimetypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setMimeTypeCallback';
			Main.openPopup(url, 'SelectMimeType', 1000, 700);
		}
		function setMimeTypeCallback(id, name)
		{
			var frm = document.forms['file'];
			frm.mime_type.value = name;
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="file" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="directory_id" value="<%=directory.getId()%>">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*300)+"px;"%>" 
			position="bottom" remember="<%=file != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="File" validate="validateFile()" helpid="file.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Path</td>
				<td><%=HTML.encodeTags(directory.getPath().toString())%></td>
			</tr>
			<%
			if (file == null || file.getLocation() == Location.EXTERNAL)
			{
				%>
				<tr>
					<td class="prompt">URL</td>
					<td><input <%=requiredClazz%> type="text" name="url" 
						value="<%=HTML.encodeTags(file == null ? Values.getString(cc.getPropertyValue("url")) : file.getUrl())%>" 
						size="40" maxlength="<%=File.MAX_URL_LENGTH%>"
						onkeyup="urlOnChange()" onchange="urlOnChange()"><br>
						<span title="Issues a HEAD request to the given URL in order to find size, MIME type, etc.">
						<input type="checkbox" name="loadMetadata" id="loadMetadata" value="1" <%=file == null ? "checked" : "" %> 
							><label for="loadMetadata">Load metadata</label></span>
					</td>
				</tr>
				<tr>
				<td class="prompt">Server</td>
				<td>
					<base:select 
						id="server_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentFileServer%>"
						denied="<%=!readCurrentFileServer%>"
						recent="<%=recentFileServers%>"
						newitem="<%=file == null%>"
						onselect="fileServerOnClick()"
					/>
				</td>
			</tr>
				<%
			}
			%>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(file == null ? Values.getString(cc.getPropertyValue("name")) : file.getName())%>" 
					size="40" maxlength="<%=File.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt"><label for="writeProtected">Write protected</label></td>
				<td><input type="checkbox" name="write_protected" id="writeProtected" value="1" 
					<%=(file != null && file.isWriteProtected()) || 
						(file == null && Values.getBoolean(cc.getPropertyValue("writeProtected"))) ? "checked" : ""%>></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Type</td>
				<td colspan="2">
					<select name="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && file != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">MIME type</td>
				<td><table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td><input <%=clazz%> type="text" name="mime_type" 
							value="<%=HTML.encodeTags(file == null ? Values.getString(cc.getPropertyValue("mimeType")) : file.getMimeType())%>" 
							size="40" maxlength="<%=File.MAX_MIMETYPE_LENGTH%>">&nbsp;</td>
						<td><base:button onclick="mimeTypeOnClick()" title="Select&hellip;"/></td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="prompt">Character set</td>
				<td>
					<select name="characterSet">
					<option value="">- n/a -
					<%
					String currentCharset = file == null ? 
						Values.getString(cc.getPropertyValue("characterSet")) : file.getCharacterSet();
					int numCommon = Config.getCommonCharsets().size();
					int i = 0;
					boolean hasMatched = false;
					for (String charset : Config.getAllCharsets())
					{
						boolean selected = false;
						if (!hasMatched)
						{
							selected = charset.equalsIgnoreCase(currentCharset);
							hasMatched |= selected;
						}
						%>
						<option value="<%=charset%>" <%=selected ? "selected" : ""%> 
							<%=i==numCommon ? "style=\"border-top: 1px solid #666666;\"" : "" %>><%=charset%>
						<%
						i++;
					}
					if (!hasMatched && currentCharset != null)
					{
						%>
						<option value="<%=currentCharset%>" selected><%=currentCharset%>
						<%
					}
					%>
					</select>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(file == null ? cc.getPropertyValue("description") : file.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'file', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>

		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
