<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.FileServer"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.MD5"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.uri.ConnectionManagerFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.ExtensionsUtil"
	import="net.sf.basedb.util.uri.ConnectionManagerUtil"
	import="java.util.Date"
	import="java.util.Collections"
	import="java.util.Map"
	import="java.util.Set"
	import="java.security.cert.X509Certificate"
	import="java.security.cert.CertificateExpiredException"
	import="java.security.MessageDigest"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.FILESERVER;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
	
	String getMd5FingerPrint(X509Certificate cert)
		throws Exception
	{
		MessageDigest md5 = MD5.newInstance();
		md5.update(cert.getEncoded());
		return formatFingerPrint(MD5.getHashString(md5));
	}
	
	String getSha1FingerPrint(X509Certificate cert)
		throws Exception
	{
		MessageDigest sha1 = MessageDigest.getInstance("SHA1");
		sha1.update(cert.getEncoded());
		return formatFingerPrint(MD5.getHashString(sha1));
	}
	
	/**
		Puts a : between every two characters and convert to uppercase
	*/
	String formatFingerPrint(String fingerPrint)
	{
		return fingerPrint.replaceAll("(..)(?=.)", "$1:").toUpperCase();
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	FileServer server = FileServer.getById(dc, itemId);
	
	final boolean writePermission = server.hasPermission(Permission.WRITE);
	final boolean deletePermission = server.hasPermission(Permission.DELETE);
	final boolean sharePermission = server.hasPermission(Permission.SET_PERMISSION);
	final boolean usePermission = server.hasPermission(Permission.USE);
	final boolean setOwnerPermission = server.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = server.isRemoved();
	final boolean isUsed = isRemoved && server.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = server.isOwner();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, server);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ConnectionManagerFactory cmf = ConnectionManagerUtil.getFactory(server.getConnectionManagerFactoryId());
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareFileServer', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="File servers" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(server.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties">
		<t:tab id="properties" title="Properties">
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this file server" : "You do not have permission to edit this file server"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!server.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this file server" : "You do not have permission to delete this file server"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=server.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this file server" : "You do not have permission to restore this file server"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this file server to other user, groups and projects" : "You do not have permission to share this file server"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'fileserver.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>	
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(server)%></i></div>
			<%
			if (server.isRemoved() || server.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=server.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(server.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">ConnectionManager</td>
				<td><%=cmf == null ? "<i>- auto -</i>" : HTML.encodeTags(cmf.getDisplayName())%></td>
			</tr>
			<tr>
				<td class="prompt">Host</td>
				<td><%=HTML.encodeTags(server.getHost())%></td>
			</tr>
			<tr>
				<td class="prompt">Username</td>
				<td><%=HTML.encodeTags(server.getUsername())%></td>
			</tr>
			<tr>
				<td class="prompt">Has password</td>
				<td><%=server.hasPassword() ? "yes" : "no"%></td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=server%>" property="owner"/></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(server.getDescription())%></td>
			</tr>
			
			<%
			String error = null;
			X509Certificate cert = null;
			try
			{
				cert = server.getServerX509Certificate();
				if (cert != null) cert.checkValidity();
			}
			catch (CertificateExpiredException ex)
			{
				error = "This certificate has expired";
			}
			catch (Exception ex)
			{
				error = ex.getMessage();
			}
			%>
			<tr>
			<td class="prompt">Server certificate</td>
			<%
			if (error != null)
			{
				%>
				<td class="error"><%=error%></td></tr>
				<%
			}
			else if (cert == null)
			{
				%>
				<td>no</td></tr>
				<%
			}
			if (cert != null)
			{
				%>
				</tr>
				<tr>
					<td class="subprompt">Issued to</td>
					<td><%=cert.getSubjectX500Principal().getName() %></td>
				</tr>
				<tr>
					<td class="subprompt">Issued by</td>
					<td><%=cert.getIssuerX500Principal().getName() %></td>
				</tr>
				<tr>
					<td class="subprompt">Valid between</td>
					<td><%=dateFormatter.format(cert.getNotBefore()) %> —
						<%=dateFormatter.format(cert.getNotAfter()) %></td>
				</tr>
				<tr>
					<td class="subprompt">Serial number</td>
					<td><%=cert.getSerialNumber() %></td>
				</tr>
				<tr>
					<td class="subprompt">MD5 fingerprint</td>
					<td><%=getMd5FingerPrint(cert)%></td>
				</tr>
				<tr>
					<td class="subprompt">SHA1 fingerprint</td>
					<td><%=getSha1FingerPrint(cert)%></td>
				</tr>
				<%
			}
			%>
			
			<%
			error = null;
			cert = null;
			try
			{
				cert = server.getClientX509Certificate();
				if (cert != null) cert.checkValidity();
			}
			catch (CertificateExpiredException ex)
			{
				error = "This certificate has expired";
			}
			catch (Exception ex)
			{
				error = ex.getMessage();
			}
			%>
			<tr>
			<td class="prompt">Client certificate</td>
			<%
			if (error != null)
			{
				%>
				<td class="error"><%=error%></td></tr>
				<%
			}
			else if (cert == null)
			{
				%>
				<td>no</td></tr>
				<%
			}
			if (cert != null)
			{
				%>
				</tr>
				<tr>
					<td class="subprompt">Issued to</td>
					<td><%=cert.getSubjectX500Principal().getName() %></td>
				</tr>
				<tr>
					<td class="subprompt">Issued by</td>
					<td><%=cert.getIssuerX500Principal().getName() %></td>
				</tr>
				<tr>
					<td class="subprompt">Valid between</td>
					<td><%=dateFormatter.format(cert.getNotBefore()) %> —
						<%=dateFormatter.format(cert.getNotAfter()) %></td>
				</tr>
				<tr>
					<td class="subprompt">Serial number</td>
					<td><%=cert.getSerialNumber() %></td>
				</tr>
				<tr>
					<td class="subprompt">MD5 fingerprint</td>
					<td><%=getMd5FingerPrint(cert)%></td>
				</tr>
				<tr>
					<td class="subprompt">SHA1 fingerprint</td>
					<td><%=getSha1FingerPrint(cert)%></td>
				</tr>
				<%
			}
			%>
			</table>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this file server" />
			</jsp:include>
			<%
			// Tables with users/groups/projects that this item is shared to
			MultiPermissions mp = new MultiPermissions(Collections.singleton(server));
			ItemResultList<User> users = mp.getUsers().list(dc);
			ItemResultList<Group> groups = mp.getGroups().list(dc);
			ItemResultList<Project> projects = mp.getProjects().list(dc);
			int totalShare = users.size() + groups.size() + projects.size();
			
			if (totalShare > 0)
			{
				%>
				<base:section 
					id="sharedTo" 
					title="<%="Shared to (" + totalShare + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table 
						id="itemsSharedTo"
						clazz="itemlist"
						columns="all"
					>
						<tbl:columndef 
							id="itemType"
							title="Item type"
						/>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="permissions"
							title="Permissions"
						/>
						<tbl:data>
							<tbl:columns>
							</tbl:columns>
							<tbl:rows>
							<%
							for (Project project : projects)
							{
								Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
								%>			
								<tbl:row>
									<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=project.isRemoved()%>"
									/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							for (Group group : groups)
							{
								Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=group.isRemoved()%>"
									/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%	
							}
							for (User user : users)
							{
								Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=user.isRemoved()%>"
									/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This file server is not shared 
				(or, you don't have permission to view the ones it is shared to).
				<%
			}			
			%>

		</div>
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
