<%-- $Id: edit_project.jsp 5812 2011-10-17 14:19:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionTemplate"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.EnumSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private static final int READ_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.READ));
private static final int USE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.USE));
private static final int WRITE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.WRITE));
private static final int DELETE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.DELETE));
private static final int SET_OWNER_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_OWNER));
private static final int SET_PERMISSION_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_PERMISSION));

private String getPermissionString(Set<Permission> permissions)
{
	StringBuilder sb = new StringBuilder();
	sb.append(permissions.contains(Permission.READ) ? "R" : "-");
	sb.append(permissions.contains(Permission.USE) ? "U" : "-");
	sb.append(permissions.contains(Permission.WRITE) ? "W" : "-");
	sb.append(permissions.contains(Permission.DELETE) ? "D" : "-");
	sb.append(permissions.contains(Permission.SET_OWNER) ? "O" : "-");
	sb.append(permissions.contains(Permission.SET_PERMISSION) ? "P" : "-");
	return sb.toString();
}
%>
<%
final Item itemType = Item.PROJECT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Project project = null;
	
	// Query to retrieve child groups
	ItemQuery<Group> groupQuery = null;
	// Query to retrieve user members
	ItemQuery<User> userQuery = null;
	
	RawDataType currentRawDataType = null;
	boolean readCurrentPermissionTemplate = true;
	PermissionTemplate currentPermissionTemplate = null;

	List<PermissionTemplate> recentPermissionTemplates = (List<PermissionTemplate>)cc.getRecent(dc, Item.PERMISSIONTEMPLATE);

	if (itemId == 0)
	{
		title = "Create project";
		cc.removeObject("item");
		currentPermissionTemplate = Base.getFirstMatching(dc, PermissionTemplate.getQuery(), "name", cc.getPropertyFilter("permissionTemplate.name"));
	}
	else
	{
		project = Project.getById(dc, itemId);
		project.checkPermission(Permission.WRITE);
		cc.setObject("item", project);
		title = "Edit project -- " + HTML.encodeTags(project.getName());
		currentRawDataType = project.getDefaultRawDataType();
		
		try
		{
			currentPermissionTemplate = project.getPermissionTemplate();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentPermissionTemplate = false;
		}
	
		groupQuery = project.getGroups();
		groupQuery.include(Include.ALL);
		groupQuery.order(Orders.asc(Hql.property("name")));
		userQuery = project.getUsers();
		userQuery.include(Include.ALL);
		userQuery.order(Orders.asc(Hql.property("name")));
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), project);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js,subtypes.js,ajax.js,json2.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Project" tab
		function validateProject()
		{
			var frm = document.forms['project'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		// Validate the "Members" tab
		function validateMembers()
		{
			return true;
		}
		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['project'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.modifiedUsers.value = Link.exportModified(frm, 'U').join(',');
				frm.modifiedGroups.value = Link.exportModified(frm, 'G').join(',');
				
				Forms.createHidden(frm, 'add:PLATFORM', Link.getActionIds(1, 'PLATFORM').join(','));
				Forms.createHidden(frm, 'remove:PLATFORM', Link.getActionIds(-1, 'PLATFORM').join(','));
				Forms.createHidden(frm, 'add:PLATFORMVARIANT', Link.getActionIds(1, 'PLATFORMVARIANT').join(','));
				Forms.createHidden(frm, 'remove:PLATFORMVARIANT', Link.getActionIds(-1, 'PLATFORMVARIANT').join(','));
				Forms.createHidden(frm, 'add:PROTOCOL', Link.getActionIds(1, 'PROTOCOL').join(','));
				Forms.createHidden(frm, 'remove:PROTOCOL', Link.getActionIds(-1, 'PROTOCOL').join(','));
				Forms.createHidden(frm, 'add:HARDWARE', Link.getActionIds(1, 'HARDWARE').join(','));
				Forms.createHidden(frm, 'remove:HARDWARE', Link.getActionIds(-1, 'HARDWARE').join(','));
				Forms.createHidden(frm, 'add:SOFTWARE', Link.getActionIds(1, 'SOFTWARE').join(','));
				Forms.createHidden(frm, 'remove:SOFTWARE', Link.getActionIds(-1, 'SOFTWARE').join(','));
				Forms.createHidden(frm, 'add:ARRAYDESIGN', Link.getActionIds(1, 'ARRAYDESIGN').join(','));
				Forms.createHidden(frm, 'remove:ARRAYDESIGN', Link.getActionIds(-1, 'ARRAYDESIGN').join(','));

				frm.submit();
			}
		}

		function init()
		{
			var frm = document.forms['project'];
			<%
			if (project == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initMembers();
			initDefaults();
			permissionTemplateOnChange();
			showPermissions(frm.autoPermissions.value, 'auto_');
		}

		function initDefaults()
		{
			var frm = document.forms['project'];
			var defaultItems = frm.defaultItems;
			Link.addNewSection(defaultItems, new Section('PLATFORM', 'Platforms'));
			Link.addNewSection(defaultItems, new Section('PLATFORMVARIANT', 'Platform variants'));
			Link.addNewSection(defaultItems, new Section('ARRAYDESIGN', 'Array designs'));
			Link.addNewSection(defaultItems, new Section('PROTOCOL', 'Protocols'));
			Link.addNewSection(defaultItems, new Section('HARDWARE', 'Hardware'));
			Link.addNewSection(defaultItems, new Section('SOFTWARE', 'Software'));
			<%
			if (project != null)
			{
				for (BasicItem defaultItem : project.getDefaultItems(dc))
				{
					String name = defaultItem instanceof Nameable ? ((Nameable)defaultItem).getName() : defaultItem.toString();
					if (defaultItem instanceof Subtypable)
					{
						ItemSubtype subtype = ((Subtypable)defaultItem).getItemSubtype();
						if (subtype != null) name += " (" + subtype.getName() + ")";
					}
					%>
					Link.addNewItem(defaultItems, new Item('<%=defaultItem.getType().name()%>', <%=defaultItem.getId()%>, '<%=HTML.javaScriptEncode(name)%>'), true);
					<%
				}
			}
			%>
		}
		function initMembers()
		{
			var frm = document.forms['project'];
			var members = frm.members;
			Link.addNewSection(members, new Section('U', 'Users'));
			<%
			if (userQuery != null)
			{
				ItemResultList<User> users = userQuery.list(dc);
				for (User user : users)
				{
					Set<Permission> permissions = project.getPermissions(user);
					%>
					Link.addNewItem(members, new Item('U',<%=user.getId()%>, '<%=HTML.javaScriptEncode(user.getName())%> [<%=getPermissionString(permissions)%>]', <%=PermissionUtil.getPermissionCode(permissions)%>));
					<%
				}
			}
			%>
			Link.addNewSection(members, new Section('G', 'Groups'));
			<%
			if (groupQuery != null)
			{
				ItemResultList<Group> groups = groupQuery.list(dc);
				for (Group group : groups)
				{
					Set<Permission> permissions = project.getPermissions(group);
					%>
					Link.addNewItem(members, new Item('G',<%=group.getId()%>, '<%=HTML.javaScriptEncode(group.getName())%> [<%=getPermissionString(permissions)%>]', <%=PermissionUtil.getPermissionCode(permissions)%>));
					<%
				}
			}
			%>
		}			
		function correctPermissions(checked, prefix)
		{
			if (!prefix) prefix = '';
			var frm = document.forms['project'];
			if (checked)
			{
				frm[prefix+'set_permission'].checked = frm[prefix+'set_permission'].checked;
				frm[prefix+'set_owner'].checked = frm[prefix+'set_owner'].checked;
				frm[prefix+'delete'].checked = frm[prefix+'delete'].checked ;
				frm[prefix+'write'].checked = frm[prefix+'write'].checked || frm[prefix+'delete'].checked || frm[prefix+'set_owner'].checked || frm[prefix+'set_permission'].checked;
				frm[prefix+'use'].checked = frm[prefix+'use'].checked || frm[prefix+'write'].checked;
				frm[prefix+'read'].checked = frm[prefix+'read'].checked || frm[prefix+'use'].checked;
			}
			else
			{
				frm[prefix+'read'].checked = frm[prefix+'read'].checked;
				frm[prefix+'use'].checked = frm[prefix+'use'].checked && frm[prefix+'read'].checked;
				frm[prefix+'write'].checked = frm[prefix+'write'].checked && frm[prefix+'use'].checked;
				frm[prefix+'delete'].checked = frm[prefix+'delete'].checked && frm[prefix+'write'].checked;
				frm[prefix+'set_owner'].checked = frm[prefix+'set_owner'].checked && frm[prefix+'write'].checked;
				frm[prefix+'set_permission'].checked = frm[prefix+'set_permission'].checked && frm[prefix+'write'].checked;
			}
		}
		function getPermissionCode(prefix)
		{
			if (!prefix) prefix = '';
			var permissionCode = 0;
			var frm = document.forms['project'];
			permissionCode += frm[prefix+'read'].checked ? <%=READ_CODE%>: 0;
			permissionCode += frm[prefix+'use'].checked ? <%=USE_CODE%>: 0;
			permissionCode += frm[prefix+'write'].checked ? <%=WRITE_CODE%>: 0;
			permissionCode += frm[prefix+'delete'].checked ? <%=DELETE_CODE%>: 0;
			permissionCode += frm[prefix+'set_owner'].checked ? <%=SET_OWNER_CODE%>: 0;
			permissionCode += frm[prefix+'set_permission'].checked ? <%=SET_PERMISSION_CODE%>: 0;
			return permissionCode;
		}
		function getPermissionString(permissionCode)
		{
			var s = '';
			s += permissionCode & <%=READ_CODE%> ? "R" : "-";
			s += permissionCode & <%=USE_CODE%> ? "U" : "-";
			s += permissionCode & <%=WRITE_CODE%> ? "W" : "-";
			s += permissionCode & <%=DELETE_CODE%> ? "D" : "-";
			s += permissionCode & <%=SET_OWNER_CODE%> ? "O" : "-";
			s += permissionCode & <%=SET_PERMISSION_CODE%> ? "P" : "-";
			return s;
		}
		function showPermissions(permissionCode, prefix)
		{
			if (!prefix) prefix = '';
			var frm = document.forms['project'];
			frm[prefix+'read'].checked = permissionCode & <%=READ_CODE%>;
			frm[prefix+'use'].checked = permissionCode & <%=USE_CODE%>;
			frm[prefix+'write'].checked = permissionCode & <%=WRITE_CODE%>;
			frm[prefix+'delete'].checked = permissionCode & <%=DELETE_CODE%>;
			frm[prefix+'set_owner'].checked = permissionCode & <%=SET_OWNER_CODE%>;
			frm[prefix+'set_permission'].checked = permissionCode & <%=SET_PERMISSION_CODE%>;
		}
		
		function permissionsOnClick(name)
		{
			var frm = document.forms['project'];
			var radio = frm[name];
			correctPermissions(radio.checked);
			var permissionCode = getPermissionCode();
			var permissionString = getPermissionString(permissionCode);
			for (var i = 0; i < frm.members.length; i++)	// >
			{
				var option = frm.members[i];
				if (option.selected && option.item.id)
				{
					option.item.value = permissionCode;
					var text = option.text.replace(/\[.*\]/, '['+permissionString+']');
					option.text = text; 
				}
			}
		}
		
		function autoPermissionsOnClick(name)
		{
			var frm = document.forms['project'];
			var radio = frm[name];
			correctPermissions(radio.checked, 'auto_');
			frm.autoPermissions.value = getPermissionCode('auto_');
		}

		function selectPermissionTemplateOnClick()
		{
			var frm = document.forms['project'];
			var url = '../../views/permissiontemplates/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setPermissionTemplateCallback';
			if (frm.permissiontemplate_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.permissiontemplate_id[1].value));
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectPermissionTemplate', 1000, 700);
		}
		function setPermissionTemplateCallback(id, name)
		{
			var frm = document.forms['project'];
			var list = frm.permissiontemplate_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			permissionTemplateOnChange();
		}
		function permissionTemplateOnChange()
		{
			var frm = document.forms['project'];
			var hasTemplate = frm.permissiontemplate_id.selectedIndex > 0;
			frm.auto_read.disabled = hasTemplate;
			frm.auto_use.disabled = hasTemplate;
			frm.auto_write.disabled = hasTemplate;
			frm.auto_delete.disabled = hasTemplate;
			frm.auto_set_owner.disabled = hasTemplate;
			frm.auto_set_permission.disabled = hasTemplate;
		}
		function membersOnChange()
		{
			var frm = document.forms['project'];
			var item = frm.members[frm.members.selectedIndex].item;
			if (item && item.id)
			{
				showPermissions(item.value);
			}
			else
			{
				showPermissions(0);
			}
		}

		function addUsersOnClick()
		{
			var ids = Link.getListIds(document.forms['project'].members, 'U');
			var excludes = ids.join(',');
			Main.openPopup('../../admin/users/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addUserCallback&permission=READ&exclude='+excludes, 'AddUsers', 1000, 700);
		}
		function addUserCallback(userId, name)
		{
			var permissionCode = getPermissionCode();
			var permissionString = getPermissionString(permissionCode);
			var item = Link.getItem('U', userId);
			if (!item) item = new Item('U', userId, name+' ['+permissionString+']', permissionCode, 0);
			Link.addItem(document.forms['project'].members, item);
		}
		function addGroupsOnClick()
		{
			var ids = Link.getListIds(document.forms['project'].members, 'G');
			<%
			if (!sc.hasSystemPermission(Permission.SHARE_TO_EVERYONE))
			{
				%>
				ids[ids.length] = '<%=SystemItems.getId(Group.EVERYONE)%>';
				<%
			}
			%>
			var excludes = ids.join(',');
			Main.openPopup('../../admin/groups/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addGroupCallback&permission=READ&exclude='+excludes, 'AddGroups', 1000, 700);
		}
		function addGroupCallback(groupId, name)
		{
			var permissionCode = getPermissionCode();
			var permissionString = getPermissionString(permissionCode);
			var item = Link.getItem('G', groupId);
			if (!item) item = new Item('G', groupId, name+' ['+permissionString+']', permissionCode, 0);
			Link.addItem(document.forms['project'].members, item);
		}
		function removeMemberOnClick()
		{
			Link.removeSelected(document.forms['project'].members);
		}

		
		function addDefaultProtocolsOnClick()
		{
			var ids = Link.getListIds(document.forms['project'].defaultItems, 'PROTOCOL');
			var excludes = ids.join(',');
			Main.openPopup('../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addDefaultProtocolCallback&exclude='+excludes, 'AddProtocols', 1000, 700);
		}
		function addDefaultProtocolCallback(protocolId, name)
		{
			var item = Link.getItem('PROTOCOL', protocolId);
			if (!item) 
			{
				var subtype = ItemSubtype.getSubtype('PROTOCOL', protocolId);
				if (subtype) name += ' ('+subtype.name+')';
				item = new Item('PROTOCOL', protocolId, name);
			}
			Link.addItem(document.forms['project'].defaultItems, item);
		}
		
		function addDefaultSoftwareOnClick()
		{
			var ids = Link.getListIds(document.forms['project'].defaultItems, 'SOFTWARE');
			var excludes = ids.join(',');
			Main.openPopup('../../admin/software/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addDefaultSoftwareCallback&exclude='+excludes, 'AddSoftware', 1000, 700);
		}
		function addDefaultSoftwareCallback(softwareId, name)
		{
			var item = Link.getItem('SOFTWARE', softwareId);
			if (!item) 
			{
				var subtype = ItemSubtype.getSubtype('SOFTWARE', softwareId);
				if (subtype) name += ' ('+subtype.name+')';
				item = new Item('SOFTWARE', softwareId, name);
			}
			Link.addItem(document.forms['project'].defaultItems, item);
		}

		function addDefaultHardwareOnClick()
		{
			var ids = Link.getListIds(document.forms['project'].defaultItems, 'HARDWARE');
			var excludes = ids.join(',');
			Main.openPopup('../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addDefaultHardwareCallback&exclude='+excludes, 'AddHardware', 1000, 700);
		}
		function addDefaultHardwareCallback(hardwareId, name)
		{
			var item = Link.getItem('HARDWARE', hardwareId);
			if (!item) 
			{
				var subtype = ItemSubtype.getSubtype('HARDWARE', hardwareId);
				if (subtype) name += ' ('+subtype.name+')';
				item = new Item('HARDWARE', hardwareId, name);
			}
			Link.addItem(document.forms['project'].defaultItems, item);
		}
		
		function addDefaultArrayDesignsOnClick()
		{
			var ids = Link.getListIds(document.forms['project'].defaultItems, 'ARRAYDESIGN');
			var excludes = ids.join(',');
			Main.openPopup('../../lims/arraydesigns/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addDefaultArrayDesignCallback&exclude='+excludes, 'AddArrayDesign', 1000, 700);
		}
		function addDefaultArrayDesignCallback(designId, name)
		{
			var item = Link.getItem('ARRAYDESIGN', designId);
			if (!item) 
			{
				item = new Item('ARRAYDESIGN', designId, name);
			}
			Link.addItem(document.forms['project'].defaultItems, item);
		}
	
		function addDefaultPlatformsOnClick()
		{
			var ids = Link.getListIds(document.forms['project'].defaultItems, 'PLATFORM');
			var excludes = ids.join(',');
			Main.openPopup('../../admin/platforms/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addDefaultPlatformCallback&exclude='+excludes, 'AddPlatform', 1000, 700);
		}
		function addDefaultPlatformCallback(platformId, name)
		{
			var item = Link.getItem('PLATFORM', platformId);
			if (!item) 
			{
				item = new Item('PLATFORM', platformId, name);
			}
			Link.addItem(document.forms['project'].defaultItems, item);
		}

		function addDefaultPlatformVariantsOnClick()
		{
			var frm = document.forms['project'];
			var selectedItem = frm.defaultItems[frm.defaultItems.selectedIndex];
			var url = '../../admin/platforms/variants/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addDefaultPlatformVariantCallback';
			var ids = Link.getListIds(frm.defaultItems, 'PLATFORMVARIANT');
			url += '&exclude='+ids.join(',');
			Main.openPopup(url, 'AddPlatformVariant', 1000, 700);
		}
		function addDefaultPlatformVariantCallback(variantId, name)
		{
			var item = Link.getItem('PLATFORMVARIANT', variantId);
			if (!item) 
			{
				item = new Item('PLATFORMVARIANT', variantId, name);
			}
			Link.addItem(document.forms['project'].defaultItems, item);
		}

		
		function removeDefaultItemsOnClick()
		{
			Link.removeSelected(document.forms['project'].defaultItems);
		}
	
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="project" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="autoPermissions" value="<%=PermissionUtil.getPermissionCode(project == null ? EnumSet.range(Permission.READ, Permission.DELETE): project.getAutoPermission())%>">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*360)+"px;"%>" 
			position="bottom" remember="<%=project != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Project" validate="validateProject()" helpid="project.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(project == null ? Values.getString(cc.getPropertyValue("name"), "New project") : project.getName())%>" 
					size="40" maxlength="<%=Project.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Default permissions</td>
				<td>
					<base:select 
						id="permissiontemplate_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentPermissionTemplate%>"
						denied="<%=!readCurrentPermissionTemplate%>"
						recent="<%=recentPermissionTemplates%>"
						newitem="<%=project == null%>"
						unselectedtext="- select a template or specify below -"
						onselect="selectPermissionTemplateOnClick()"
						onchange="permissionTemplateOnChange()"
					/>
				
					<input type="checkbox" id="autoRead" checked name="auto_read" 
						onClick="autoPermissionsOnClick('auto_read')"><label for="autoRead">Read</label><br>
					<input type="checkbox" id="autoUse" checked name="auto_use" 
						onClick="autoPermissionsOnClick('auto_use')"><label for="autoUse">Use</label><br>
					<input type="checkbox" id="autoWrite" name="auto_write" 
						onClick="autoPermissionsOnClick('auto_write')"><label for="autoWrite">Write</label><br>
					<input type="checkbox" id="autoDelete" name="auto_delete" 
						onClick="autoPermissionsOnClick('auto_delete')"><label for="autoDelete">Delete</label><br>
					<input type="checkbox" id="autoSetOwner" name="auto_set_owner" 
						onClick="autoPermissionsOnClick('auto_set_owner')"><label for="autoSetOwner">Set owner</label><br>
					<input type="checkbox" id="autoSetPermission" name="auto_set_permission" 
						onClick="autoPermissionsOnClick('auto_set_permission')"><label for="autoSetPermission">Set permission</label><br>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(project == null ? cc.getPropertyValue("description") : project.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'project', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>

		<t:tab id="members" title="Members" validate="validateMembers()" helpid="project.edit.members">

		<table >
		<tr valign="top">
		<td>
			<b>Members</b><br>
			<select <%=clazz%> name="members" size="15" multiple onChange="membersOnChange()" 
				style="width: 22em;">
			</select>
			<input type="hidden" name="modifiedUsers" value="">
			<input type="hidden" name="modifiedGroups" value="">
		</td>
		<td>
			<br>
			<b>Permissions</b><br>
			<input type="checkbox" id="read" checked name="read" onClick="permissionsOnClick('read')"><label for="read">Read</label><br>
			<input type="checkbox" id="user" checked name="use" onClick="permissionsOnClick('use')"><label for="use">Use</label><br>
			<input type="checkbox" id="write" name="write" onClick="permissionsOnClick('write')"><label for="write">Write</label><br>
			<input type="checkbox" id="delete" name="delete" onClick="permissionsOnClick('delete')"><label for="delete">Delete</label><br>
			<input type="checkbox" id="setOwner" name="set_owner" onClick="permissionsOnClick('set_owner')"><label for="setOwner">Set owner</label><br>
			<input type="checkbox" id="setPermission" name="set_permission" onClick="permissionsOnClick('set_permission')"><label for="setPermission">Set permission</label><br>
		</td>
		<td>
			<br>
			<table width="150">
			<tr><td><base:button 
				clazz="leftaligned buttonclass"
				onclick="addUsersOnClick()" 
				title="Add&nbsp;users&hellip;" 
				tooltip="Add users to this project"
				/></td></tr>
			<tr><td><base:button 
				clazz="leftaligned buttonclass"
				onclick="addGroupsOnClick()" 
				title="Add&nbsp;groups&hellip;"  
				tooltip="Add groups to this project"
			/></td></tr>
			<tr><td><base:button 
				clazz="leftaligned buttonclass"
				onclick="removeMemberOnClick()" 
				title="Remove" 
				tooltip="Remove the selected members from this project"
			/></td></tr>
			</table>
		</td>
		</tr>
		</table>
		</t:tab>
		
		<t:tab id="defaults" title="Default items"  helpid="project.edit.defaults">
			<table class="form" cellspacing="2" border="0" cellpadding="0">
			<tr>
				<td class="prompt">Raw data type</td>
				<td>
					<select name="rawdatatype">
					<option value="">- none -</option>
					<%
					for (RawDataType rdt : RawDataTypes.getSortedRawDataTypes(new RawDataTypes.NameComparator()))
					{
						if (rdt.isStoredInDb())
						{
							String selected = rdt.equals(currentRawDataType) ? "selected" : "";
							%>
							<option value="<%=rdt.getId()%>" <%=selected%>><%=HTML.encodeTags(rdt.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			</table>

			<table class="form" cellspacing="2" border="0" cellpadding="0" width="100%">				
				<tr valign="top">
					<td>
						<b>Default items</b><br>
						<select <%=clazz%> name="defaultItems" size="20" multiple style="width: 100%;">
						</select>
					</td>
					<td>
						<br>
						<table width="200">
						<tr><td><base:button 
							clazz="leftaligned buttonclass"
							onclick="addDefaultPlatformsOnClick()" 
							title="Add&nbsp;platforms&hellip;" 
							tooltip="Add default platforms to this project"
							/></td></tr>
						<tr><td><base:button 
							clazz="leftaligned buttonclass"
							onclick="addDefaultPlatformVariantsOnClick()" 
							title="Add&nbsp;variants&hellip;" 
							tooltip="Add default platform variants to this project"
							/></td></tr>
						<tr><td><base:button 
							clazz="leftaligned buttonclass"
							onclick="addDefaultProtocolsOnClick()" 
							title="Add&nbsp;protocols&hellip;" 
							tooltip="Add default protocols to this project"
							/></td></tr>
						<tr><td><base:button 
							clazz="leftaligned buttonclass"
							onclick="addDefaultHardwareOnClick()" 
							title="Add&nbsp;hardware&hellip;"  
							tooltip="Add default hardware to this project"
						/></td></tr>
						<tr><td><base:button 
							clazz="leftaligned buttonclass"
							onclick="addDefaultSoftwareOnClick()" 
							title="Add&nbsp;software&hellip;"  
							tooltip="Add default software to this project"
						/></td></tr>
						<tr><td><base:button 
							clazz="leftaligned buttonclass"
							onclick="addDefaultArrayDesignsOnClick()" 
							title="Add&nbsp;array&nbsp;designs&hellip;"  
							tooltip="Add default array designs to this project"
						/></td></tr>
						<tr><td><base:button 
							clazz="leftaligned buttonclass"
							onclick="removeDefaultItemsOnClick()" 
							title="Remove" 
							tooltip="Remove the selected items from this project"
						/></td></tr>
						</table>
					</td>
				</tr>
			</table>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
